/*
 *ΥåԤ
  ºݤ˥å夹Τddic_ent.c
  (ΤsdicʣĤ⤷ʤ)
  *ĿѤμⰷ
 */
#include <stdlib.h>

#include <wtype.h>
#include <record.h>

#include "dic_cache.h"
#include "xchar.h"
#include "ddic.h"

static struct dic_cache{
  sdic_t dic;/*ޥμ*/
  ddic_t cache;/*å*/
  ddic_t priv;/*Ŀͼ*/
}g_cache;

static struct conjugate_table{
  xchar t[2];
  int cc;
  int ct;
  int cst;
}ctab[]={
  /*K5 5 ֽ񤯡*/
  {{HK_KA,0},CC_K5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_KO,0},CC_K5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_KI,0},CC_K5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_I,0},CC_K5,CT_RENYOU,CST_DEFAULT},
  {{HK_KU,0},CC_K5,CT_SYUSI,CST_DEFAULT},
  {{HK_KU,0},CC_K5,CT_RENTAI,CST_DEFAULT},
  {{HK_KE,0},CC_K5,CT_KATEI,CST_DEFAULT},
  {{HK_KE,0},CC_K5,CT_MEIREI,CST_DEFAULT},
  /* ֹԤ ϢѷˡֹԤäפΤ̤  ǤϤʤ*/
  {{HK_KA,0},CC_C5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_KO,0},CC_C5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_TT,0},CC_C5,CT_RENYOU,CST_V_RENYOU_TA},
  {{HK_I,0},CC_C5,CT_RENYOU,CST_DEFAULT},
  {{HK_KU,0},CC_C5,CT_SYUSI,CST_DEFAULT},
  {{HK_KU,0},CC_C5,CT_RENTAI,CST_DEFAULT},
  {{HK_KE,0},CC_C5,CT_KATEI,CST_DEFAULT},
  {{HK_KE,0},CC_C5,CT_MEIREI,CST_DEFAULT},
  /*G5 5 ֶĤ*/
  {{HK_GA,0},CC_G5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_GO,0},CC_G5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_GI,0},CC_G5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_I,0},CC_G5,CT_RENYOU,CST_DEFAULT},
  {{HK_GU,0},CC_G5,CT_SYUSI,CST_DEFAULT},
  {{HK_GU,0},CC_G5,CT_RENTAI,CST_DEFAULT},
  {{HK_GE,0},CC_G5,CT_KATEI,CST_DEFAULT},
  {{HK_GE,0},CC_G5,CT_MEIREI,CST_DEFAULT},
  /*S5 5 ִŤ䤫*/
  {{HK_SA,0},CC_S5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_SO,0},CC_S5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_SI,0},CC_S5,CT_RENYOU,CST_DEFAULT},
  {{HK_SU,0},CC_S5,CT_SYUSI,CST_DEFAULT},
  {{HK_SU,0},CC_S5,CT_RENTAI,CST_DEFAULT},
  {{HK_SE,0},CC_S5,CT_KATEI,CST_DEFAULT},
  {{HK_SE,0},CC_S5,CT_MEIREI,CST_DEFAULT},
  /*5 Ǥġ*/
  {{HK_TA,0},CC_T5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_TO,0},CC_T5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_TI,0},CC_T5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_TT,0},CC_T5,CT_RENYOU,CST_V_RENYOU_TA},
  {{HK_TU,0},CC_T5,CT_SYUSI,CST_DEFAULT},
  {{HK_TU,0},CC_T5,CT_RENTAI,CST_DEFAULT},
  {{HK_TE,0},CC_T5,CT_KATEI,CST_DEFAULT},
  {{HK_TE,0},CC_T5,CT_MEIREI,CST_DEFAULT},
  /*ʹ5 ֻ̡*/
  {{HK_NA,0},CC_N5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_NO,0},CC_N5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_NI,0},CC_N5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_N ,0},CC_N5,CT_RENYOU,CST_DEFAULT},
  {{HK_NU,0},CC_N5,CT_SYUSI,CST_DEFAULT},
  {{HK_NU,0},CC_N5,CT_RENTAI,CST_DEFAULT},
  {{HK_NE,0},CC_N5,CT_KATEI,CST_DEFAULT},
  {{HK_NE,0},CC_N5,CT_MEIREI,CST_DEFAULT},
  /*޹5 */
  {{HK_MA,0},CC_M5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_MO,0},CC_M5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_MI,0},CC_M5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_N ,0},CC_M5,CT_RENYOU,CST_DEFAULT},
  {{HK_MU,0},CC_M5,CT_SYUSI,CST_DEFAULT},
  {{HK_MU,0},CC_M5,CT_RENTAI,CST_DEFAULT},
  {{HK_ME,0},CC_M5,CT_KATEI,CST_DEFAULT},
  {{HK_ME,0},CC_M5,CT_MEIREI,CST_DEFAULT},
  /*й5 ֡*/
  {{HK_BA,0},CC_B5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_BO,0},CC_B5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_BI,0},CC_B5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_N ,0},CC_B5,CT_RENYOU,CST_DEFAULT},
  {{HK_BU,0},CC_B5,CT_SYUSI,CST_DEFAULT},
  {{HK_BU,0},CC_B5,CT_RENTAI,CST_DEFAULT},
  {{HK_BE,0},CC_B5,CT_KATEI,CST_DEFAULT},
  {{HK_BE,0},CC_B5,CT_MEIREI,CST_DEFAULT},
  /*5 (롢ޤ)*/
  {{HK_RA,0},CC_R5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_RO,0},CC_R5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_RI,0},CC_R5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_TT ,0},CC_R5,CT_RENYOU,CST_V_RENYOU_TA},
  {{HK_RU,0},CC_R5,CT_SYUSI,CST_DEFAULT},
  {{HK_RU,0},CC_R5,CT_RENTAI,CST_DEFAULT},
  {{HK_RE,0},CC_R5,CT_KATEI,CST_DEFAULT},
  {{HK_RE,0},CC_R5,CT_MEIREI,CST_DEFAULT},
  /*5 ä ֤̿*/
  {{HK_RA,0},CC_L5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_RO,0},CC_L5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_RI,0},CC_L5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_TT ,0},CC_L5,CT_RENYOU,CST_V_RENYOU_TA},
  {{HK_I ,0},CC_L5,CT_RENYOU,CST_V_RENYOU_5},
  {{HK_RU,0},CC_L5,CT_SYUSI,CST_DEFAULT},
  {{HK_RU,0},CC_L5,CT_RENTAI,CST_DEFAULT},
  {{HK_RE,0},CC_L5,CT_KATEI,CST_DEFAULT},
  {{HK_I,0},CC_L5,CT_MEIREI,CST_DEFAULT},
  /*5 ʧ*/
  {{HK_WA,0},CC_W5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_O,0},CC_W5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_I,0},CC_W5,CT_RENYOU,CST_DEFAULT},
  {{HK_TT ,0},CC_W5,CT_RENYOU,CST_V_RENYOU_TA},
  {{HK_U,0},CC_W5,CT_SYUSI,CST_DEFAULT},
  {{HK_U,0},CC_W5,CT_RENTAI,CST_DEFAULT},
  {{HK_E,0},CC_W5,CT_KATEI,CST_DEFAULT},
  {{HK_E,0},CC_W5,CT_MEIREI,CST_DEFAULT},
  /*5ʡ𤦡Ϣѷ֤*/
  {{HK_WA,0},CC_U5,CT_MIZEN,CST_V_MIZEN_5},
  {{HK_O,0},CC_U5,CT_MIZEN,CST_V_MIZEN_U},
  {{HK_I,0},CC_U5,CT_RENYOU,CST_DEFAULT},
  {{HK_U ,0},CC_U5,CT_RENYOU,CST_DEFAULT},
  {{HK_U,0},CC_U5,CT_SYUSI,CST_DEFAULT},
  {{HK_U,0},CC_U5,CT_RENTAI,CST_DEFAULT},
  {{HK_E,0},CC_U5,CT_KATEI,CST_DEFAULT},
  {{HK_E,0},CC_U5,CT_MEIREI,CST_DEFAULT},
  /*졢 ָ()סֽ()*/
  {{0,0},CC_KS1,CT_MIZEN,CST_DEFAULT},
  {{0,0},CC_KS1,CT_RENYOU,CST_DEFAULT},
  {{HK_RU,0},CC_KS1,CT_SYUSI,CST_DEFAULT},
  {{HK_RU,0},CC_KS1,CT_RENTAI,CST_DEFAULT},
  {{HK_RE,0},CC_KS1,CT_KATEI,CST_DEFAULT},
  {{HK_YO,0},CC_KS1,CT_MEIREI,CST_V_MEIREI_},
  {{HK_RO,0},CC_KS1,CT_MEIREI,CST_DEFAULT},
  /*()*/
  /*
  {{HK_KO,0},CC_KV,CT_MIZEN,CST_DEFAULT},
  {{HK_KI,0},CC_KV,CT_RENYOU,CST_DEFAULT},
  {{HK_KU,HK_RU},CC_KV,CT_SYUSI,CST_DEFAULT},
  {{HK_KU,HK_RU},CC_KV,CT_RENTAI,CST_DEFAULT},
  {{HK_KU,HK_RE},CC_KV,CT_KATEI,CST_DEFAULT},
  {{HK_KO,HK_I},CC_KV,CT_MEIREI,CST_DEFAULT},
  */
  /* ()*/
  {{HK_SI,0},CC_SV,CT_MIZEN,CST_V_MIZEN_SI},
  {{HK_SE,0},CC_SV,CT_MIZEN,CST_V_MIZEN_SE},
  {{HK_SA,0},CC_SV,CT_MIZEN,CST_V_MIZEN_SA},
  {{HK_SI,0},CC_SV,CT_RENYOU,CST_DEFAULT},
  {{HK_SU,HK_RU},CC_SV,CT_SYUSI,CST_DEFAULT},
  {{HK_SU,HK_RU},CC_SV,CT_RENTAI,CST_DEFAULT},
  {{HK_SU,HK_RE},CC_SV,CT_KATEI,CST_DEFAULT},
  {{HK_SE,HK_YO},CC_SV,CT_MEIREI,CST_V_MEIREI_},
  {{HK_SI,HK_RO},CC_SV,CT_MEIREI,CST_DEFAULT},
  /* 롢¤󤸤*/
  {{HK_ZI,0},CC_ZV,CT_MIZEN,CST_DEFAULT},
  {{HK_ZE,0},CC_ZV,CT_MIZEN,CST_DEFAULT},
  {{HK_ZA,0},CC_ZV,CT_MIZEN,CST_DEFAULT},
  {{HK_ZI,0},CC_ZV,CT_RENYOU,CST_DEFAULT},
  {{HK_ZU,HK_RU},CC_ZV,CT_SYUSI,CST_DEFAULT},
  {{HK_ZU,HK_RU},CC_ZV,CT_RENTAI,CST_DEFAULT},
  {{HK_ZU,HK_RE},CC_ZV,CT_KATEI,CST_DEFAULT},
  {{HK_ZE,HK_YO},CC_ZV,CT_MEIREI,CST_V_MEIREI_},
  {{HK_ZI,HK_RO},CC_ZV,CT_MEIREI,CST_DEFAULT},
  /* #KY ƻ*/
  {{HK_KA,HK_RO},CC_A,CT_MIZEN,CST_DEFAULT},
  {{HK_KA,HK_TT},CC_A,CT_RENYOU,CST_DEFAULT},
  {{HK_KU,0},CC_A,CT_RENYOU,CST_A_RENYOU_NA},
  {{HK_I,0},CC_A,CT_SYUSI,CST_DEFAULT},
  {{HK_I,0},CC_A,CT_RENTAI,CST_DEFAULT},
  {{HK_KE,HK_RE},CC_A,CT_KATEI,CST_DEFAULT},
  {{0,0},CC_A_U,CT_SYUSI,CST_DEFAULT},
  {{0,0},CC_A,CT_HEAD,CST_DEFAULT},
  /*ư*/
  {{HK_DA,HK_RO},CC_AJV,CT_MIZEN,CST_DEFAULT},
  {{HK_DA,HK_TT},CC_AJV,CT_RENYOU,CST_DEFAULT},
  {{HK_DE,0},CC_AJV,CT_RENYOU,CST_AJV_RENYOU_A},
  {{HK_NI,0},CC_AJV,CT_RENYOU,CST_AJV_RENYOU_NA},
  {{HK_DA,0},CC_AJV,CT_SYUSI,CST_DEFAULT},  
  {{HK_NA,0},CC_AJV,CT_RENTAI,CST_DEFAULT},
  {{HK_NA,HK_RA},CC_AJV,CT_KATEI,CST_DEFAULT},
  {{0,0},CC_AJV,CT_HEAD,CST_DEFAULT},
  /**/
  {{-1,-1},0,0},
};

/*ؤΥ*/
static void fill_conjugated_ent(xstr *x,struct seq_ent *);
static void fill_kv_conjugated_ent(xstr *x,struct seq_ent *);
static void calc_seq_flags(struct seq_ent *);

/*Ŀͼ*/
static void init_private_dic();
static void add_word_to_private_dic();

/*
  ñγѤμबɽΥȥȰפñ򼭽񤫤õ
  */
void fill_conjugated_ent(xstr *x,struct seq_ent *s)
{
  struct conjugate_table *p;
  xchar l1=0,l2=0;
  xstr z;
  xstr eow;/*Ѹ*/
  z.str = x->str;
  z.len = x->len;

  /*Ǹΰʸʸ*/
  if ( x->len >0 ){
    l1 = x->str[x->len-1];
    if ( x->len >1 ){
      l2 = x->str[x->len-2];
    }
  }

  /*ƳѥѥФ*/
  for ( p = &ctab[0] ; p->t[0] >=0 ; p++){
    eow.str = p->t;
  if(p->t[0] == 0){
      /*촴ΤߤǤڤ*/
      z.len = x->len;
      sdic_fill_seq_ent_by_xstr(g_cache.dic,&z,s,0,p->cc,p->ct,p->cst);
  }else if (p->t[1] == 0){
      /*Ѥʬʸ*/
      eow.len = 1;
      if ( l1 == p->t[0]){
          z.len = x->len - 1;
	sdic_fill_seq_ent_by_xstr(g_cache.dic,&z,s,&eow,p->cc,p->ct,p->cst);
      }
  }else{
      eow.len = 2;
      /*Ѥʬʸ*/
      if ( l2 == p->t[0] && l1 == p->t[1]){
	z.len = x->len -2;
	sdic_fill_seq_ent_by_xstr(g_cache.dic,&z,s,&eow,p->cc,p->ct,p->cst);
      }
    }
  } 
  fill_kv_conjugated_ent(x,s);
}

/**/
void fill_kv_conjugated_ent(xstr *x,struct seq_ent *s)
{
  xchar l1,l2,l3;
  xstr eow;
  int ct=0;
  l1 = x->str[x->len -1];
  l2 = 0;
  l3 = 0;
  if ( x->len > 1 ){
    l2 = x->str[x->len -2];
    if ( x->len > 2 ){
      l3 = x->str[x->len-3];
    }
  }
  eow.len = 0;
  switch(l1 ){
  case HK_KI:
    ct = CT_KATEI;
    break;
  case HK_KO:
    ct = CT_MIZEN;
    break;
  case HK_I:
    if ( l2 != HK_KO ){
      return ;
    }
    ct = CT_MEIREI;
    break;
  case HK_RE:
    if ( l2 != HK_KU ){
      return ;
    }
    ct = CT_KATEI;
    break;
  case HK_RU:
    if ( l2 != HK_KU ){
      return ;
    }
    ct = CT_SYUSI;
    break;
  case HK_XYA:
    if ( l2 != HK_RI || l3 != HK_KU){
      return ;
    }
    /*ѷϡ*/
    return ;
    break;
  default:
    break;
  }
  sdic_fill_seq_ent_by_xstr(g_cache.dic,x,s,&eow,
			    CC_KV,ct,CST_DEFAULT);
}

void calc_seq_flags(struct seq_ent *e)
{
  int i;
  for ( i = 0 ; i < e->nr_dic_ents ; i++){
    int p;
    p = wtype_get_pos(e->dic_ents[i]->type);
    switch(p ){
    case POS_NOUN:
    {
      int c;
      c = wtype_get_cos(e->dic_ents[i]->type);
      if ( c == COS_NN ){
	e->flags |= NF_NUM;
      }else if ( c == COS_JN ){
	e->flags |= NF_NAME;
      }
    }
    break;
    case POS_PRE:
    case POS_SUC:
    {
      int c;
      c = wtype_get_cos(e->dic_ents[i]->type);
      if ( c == COS_JN ){
	e->flags |= SF_JN;
      }else if ( c == COS_NN ){
	e->flags |= SF_NUM;
      }
    }
    break;
    }
  }
}

void add_word_to_private_dic()
{
  int nr;
  xstr *word,*yomi,*tmp;
  wtype_t wt;
  char *cstr;
  int freq;
  struct seq_ent *se;

  nr = get_nr_values();
  if ( nr < 4 ){
    return ;
  }
  yomi = get_nth_xstr(0);
  word = get_nth_xstr(1);
  tmp = get_nth_xstr(2);
  cstr = xstr_to_cstr(tmp);
  free_xstr(tmp);
  name_to_wtype(cstr,&wt);
  free(cstr);
  freq = get_nth_value(3);

  se = ddic_alloc_seq_ent_by_xstr(g_cache.priv,yomi);
  ddic_push_back_dic_ent(se,word,wt,freq);
}

void init_private_dic()
{
  if ( select_section("PRIVATEDIC",0) == -1 ){
    return ;
  }
  if ( select_first_column() == -1 ){
    return ;
  }
  do {
    add_word_to_private_dic();
  }while(select_next_column() != -1);
}

int init_dic_cache(sdic_t s)
{
  g_cache.dic = s;
  g_cache.cache = create_ddic();
  g_cache.priv = create_ddic();
  init_private_dic();
  return 0;
}

struct seq_ent *cache_get_seq_ent(xstr *x)
{
  struct seq_ent *s;
  /*åˤФ֤*/
  s = ddic_find_seq_ent_by_xstr(g_cache.cache,x);
  if ( !s ){
    s = ddic_alloc_seq_ent_by_xstr(g_cache.cache,x);

    /*ޤեå*/
    sdic_fill_seq_ent_by_xstr(g_cache.dic,x,s,0,CC_NONE,CT_NONE,CST_NONE);
    /*ư̾ȤƤθ*/
    sdic_fill_seq_ent_by_xstr(g_cache.dic,x,s,0,CC_AJV,CT_NONE,CST_NONE);
    /*Ĥ˳Ѥ륨ȥ򸡺*/
    fill_conjugated_ent(x,s);

    /*Ŀͼ񤫤Υեå*/

    if (s ->nr_dic_ents == 0){
      /*̵ʥȥΤcache*/
      ddic_release_seq_ent(g_cache.cache,x);
      return 0;
    }

    /*٤Ƥdic_entФflag׻*/
    calc_seq_flags(s);
  }
  return s;
}

void shrink_cache()
{
  shrink_ddic(g_cache.cache);
}
