/*
  Υå񥭥åΥȥ
  Ƥθߥƥ֤ѴƥȤȤäƤʤ
  Τߤ˲뤳ȤǤ롣
 */

#include <stdlib.h>
#include <string.h>
#include <conf.h>
#include "dic_session.h"
#include "ddic_tree.h"

/*32 bitΥޥȤ*/
#define MAX_SESSION 32

static struct dic_session *g_sessions;
static struct dic_session *g_current_session;
static struct dic_session *g_anonymous_session;

struct dic_session *create_session()
{
  int i;
  for ( i = 0 ; i < MAX_SESSION ; i++){
    if ( g_sessions[i].is_free ){
      g_sessions[i].is_free = 0;
      return &g_sessions[i];
    }
  }
  return 0;
}

void activate_session(struct dic_session *d)
{
  if ( !d){
    d = g_anonymous_session;
  }
  g_current_session = d;
}

void release_session(struct dic_session *d)
{
  if ( g_current_session == d){
    g_current_session = 0;
  }
  d->is_free = 1;
  invalidate_seq_node_mask(~d->mask);
}

int get_current_session_mask()
{
  if ( g_current_session ){
    return g_current_session->mask;
  }
  return 0;
}

void init_sessions()
{
  int i;
  g_sessions = malloc(sizeof(struct dic_session)*MAX_SESSION);
  for ( i = 0 ; i < MAX_SESSION ; i++){
    g_sessions[i].id = i;
    g_sessions[i].mask = 1<<i;
    g_sessions[i].is_free = 1;
  }
  g_current_session = 0;
  g_anonymous_session = create_session();
}
