/*"123" "ABC" Τ褦ʥȥФ礻ξ
  Ƥθ򤳤
  ѿϤȤꤢȾѤΤߤϤΤб롣
*/

#include "dic_ent.h"
#include "xchar.h"

static wtype_t wt_num;

static char *ascii_wide_tab[]={
    0,"","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","",
};

static int kj_num_tab[]={KJ_0,KJ_1,KJ_2,KJ_3,KJ_4,
			 KJ_5,KJ_6,KJ_7,KJ_8,KJ_9};

static void compose_num_component(xstr *,int);
static xchar get_kj_num(int );

xchar get_kj_num(int n)
{
  if ( n > 9 || n < 1 ){
    return KJ_10;
  }
  return kj_num_tab[n];
}

void compose_num_component(xstr *xs,int num)
{
  int n[4],i;
  int a[4] = { 0 , KJ_10,KJ_100,KJ_1000};
  for ( i = 0 ; i < 4 ; i++){
    n[i] = num-(num/10)*10;
    num /= 10;
  }
  /*10,100,1000ΰ*/
  for ( i = 3 ; i > 0 ; i--){
    if ( n[i] > 0){
      if ( n[i] > 1 ){
	xstrappend(xs,get_kj_num(n[i]));
      }
      xstrappend(xs,a[i]);
    }
  }
  /*1ΰ*/
  if ( n[0] ){
    xstrappend(xs,get_kj_num(n[0]));
  }
}

int get_nr_dic_ents_of_ext_ent(seq_ent_t se,xstr *xs)
{
  if ( is_num_xstr(xs) ){
    int num = xstrtoi(xs);
    if ( num > 0 && num < 100000000){
      /*ȥӥ*/
      return 2;
    }
    /*ӥΤ*/
    return 1;
  }
  return 0;
}

int get_nth_dic_ent_str_of_ext_ent(seq_ent_t se,xstr *xs,int nth,xstr *dest)
{
  switch ( nth ){
  case 0:
    dest->len = xs->len;
    dest->str = xstr_dup_str(xs);
    return 0;
  case 1:
    {
      int num,i;
      int n[10];
      num = xstrtoi(xs);
      for ( i = 0 ; i < 10 ; i ++){
	n[i] = num-(num/10000)*10000;
	num = num/10000;
      }
      dest->len = 0;
      dest->str = 0;
      if ( n[1] ){
	compose_num_component(dest,n[1]);
	xstrappend(dest,KJ_10000);
      }
      compose_num_component(dest,n[0]);
    }
  }
  return 0;
}

int get_nth_dic_ent_wtype_of_ext_ent(xstr *xs,int nth,wtype_t *wt)
{
  if ( is_num_xstr(xs) ){
    *wt = wt_num;
    return 0;
  }
  return -1;
}

void init_ext_ent()
{
  name_to_wtype("",&wt_num);
}
