/*
  ʸФ򥽡Ȥ롣
  Ūˤ϶ܤʸ⸫ơñηˤɾ򤹤롣
  ֤äκ⤹롣
 */
#include <stdlib.h>
#include "main.h"
#include "context.h"
#include "segment.h"

static void eval_segment(struct seg_ent *);
static void eval_candidate(struct cand_ent *);
static void sort_segment(struct seg_ent *);
static int candidate_compare_func(const void *,const void *);
static void check_dupl_candidate(struct seg_ent *);
static void release_redundant_candidate(struct seg_ent *);

void release_redundant_candidate(struct seg_ent *e)
{
  int i,j;
  for ( i = 0 ; i < e->cand_count && e->cands[i]->score ; i++);
  if ( i < e->cand_count ){
    for ( j = i ; j < e->cand_count ; j++){
      release_cand_ent(e->cands[j]);
    }
    e->cand_count = i;
  }
}

int candidate_compare_func(const void *p1,const void *p2)
{
  const struct cand_ent **c1= p1,**c2=p2;
  return (*c2)->score - (*c1)->score;
}

void sort_segment(struct seg_ent *s)
{
  qsort(s->cands,s->cand_count,
	sizeof(struct cand_ent *),
	candidate_compare_func);
}

void check_dupl_candidate(struct seg_ent *s)
{
  int i,j;
  for ( i = 0 ; i < s->cand_count -1;i++){
    for ( j = i+1 ; j < s->cand_count ; j++){
      if (! xstrcmp(&s->cands[i]->str,&s->cands[j]->str)){
	/*롼ɤޥåΤ֤Ȥ٤*/
	s->cands[j]->score = 0;
      }
    }
  }
}

void eval_candidate(struct cand_ent *c)
{
  int i;
  c->score = 1;
  /*ޤñ٤ˤscoreû*/
  for ( i = 0 ; i < c->nr_words && i < 1; i++){
    struct cand_elm *elm = &c->elm[i];
    if ( elm->nth >= 0){
      c->score += get_nth_dic_ent_freq(elm->s,elm->nth)*elm->bias;
    }
  }
  if ( c->nr_words ){
    c->score *= 10;
    c->score /= (c->nr_words*c->nr_words*c->nr_words);
  }
  c->score += 1;
}

void eval_segment(struct seg_ent *s)
{
  int i;
  for ( i = 0 ; i < s->cand_count ; i++){
    eval_candidate(s->cands[i]);
  }
}

/*ƤФ륨ȥݥ*/
void sort_candidate(struct anthy_context *c,int nth)
{
    int i;
    /*ޤɾ롣*/
    for ( i = nth ; i < c->seg_count ; i++){
        eval_segment(get_nth_segment(c,i));
    }
    /*Ĥ¤Ӥ*/
    for ( i = nth ; i < c->seg_count ; i++){
        sort_segment(get_nth_segment(c,i));
    }
    /*֤äȥ㤤0դ*/
    for ( i = nth ; i < c->seg_count ; i++){
      check_dupl_candidate(get_nth_segment(c,i));
    }
    /*⤦¤Ӥ*/
    for ( i = nth ; i < c->seg_count ; i++){
        sort_segment(get_nth_segment(c,i));
    }
    /*ɾ0θ*/
    for ( i = nth ; i < c->seg_count ; i++){
      release_redundant_candidate(get_nth_segment(c,i));
    }
    /*θ*/
    for ( i = nth ; i < c->seg_count ; i++){
      proc_swap_candidate(get_nth_segment(c,i));
    }
}
