/*
  ʸФƸΥꥹȤ롣
  make_candidates()contextƤФ롣
  expand_segment()ƽФ¤βϤԤäƤ餦
  commit_split_ent()ǹ¤ФƸƤ롣
 */
/*
  0,ʸ᤽Τޤʿ̾Ҳ̾Υѥɲ
  1,Ĥñʬѥ롣
   segexpandʸʬ䤷ơι¤segstructɾ
   ʸι¤ʤСʻ򤢤Ƥcommit_split_entˤä
   ߥåȤ롣
  2,줾ñѥñƤƸɲ
 */
#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "segexpand.h"

struct seg_ent *g_seg;

static void push_back_noconv_candidate();
static void push_back_singleword_candidate();
static void push_back_candidate(struct cand_ent *e);
static int enum_candidates(struct split_ent *e,struct cand_ent *,int);
static void print_candidate(struct cand_ent *c);
static struct cand_ent *dup_candidate(struct cand_ent *c);

/*Ƶ1ñ줺ĸƤƤ*/
int enum_candidates(struct split_ent *s,struct cand_ent *c,int n)
{
  int i,p;
  struct cand_ent *cand;
  int nr_cands=0;
  if ( n == s->nr_words ){
    /**/
    /*ʸβϤʤäʬʸɲ*/
    xstr tail;
    tail.len = s->xs.len - (s->from + s->len);
    tail.str = &s->xs.str[s->from+s->len];
    xstrcat(&c->str,&tail);
    push_back_candidate(dup_candidate(c));
    return 1;
  }

  p = get_nr_dic_ents(s->we[n].se,&s->we[n].str);
  /*ʻξˤ̤ѴǼñعԤ*/
  if ( wtype_get_pos(s->we[n].wt) == POS_INVAL || p == 0){
    cand = dup_candidate(c);
    cand->elm[n].nth = -1;
    xstrcat(&cand->str,&s->we[n].str);
    nr_cands = enum_candidates(s,cand,n+1);
    release_cand_ent(cand);
    return nr_cands;
  }
  /*ʻ줬ƤƤΤǡʻ˥ޥåΤƤ*/
  for ( i = 0 ; i < p ; i++){
    wtype_t wt;
    get_nth_dic_ent_wtype(s->we[n].se,&c->str,i,&wt);
    if ( !wtypecmp(wt,s->we[n].wt)){
      xstr xs;
      cand = dup_candidate(c);
      get_nth_dic_ent_str(cand->elm[n].s,&s->we[n].str,i,&xs);
      cand->elm[n].nth = i;
      xstrcat(&cand->str,&xs);
      nr_cands += enum_candidates(s,cand,n+1);
      release_cand_ent(cand);
    }
  }
  return nr_cands;
}

struct cand_ent *dup_candidate(struct cand_ent *c)
{
  struct cand_ent *e;
  int i;
  e = (struct cand_ent *)malloc(sizeof(struct cand_ent));
  e->nr_words = c->nr_words;
  e->str.len = c->str.len;
  e->str.str = xstr_dup_str(&c->str);
  e->elm = malloc(sizeof(struct cand_elm)*c->nr_words);
  for ( i = 0 ; i < e->nr_words ; i++){
    e->elm[i] = c->elm[i];
  }
  return e;
}

void push_back_candidate(struct cand_ent *e)
{
  /*g_seg˸eɲ*/
  g_seg->cand_count++;
  g_seg->cands = (struct cand_ent **)
    realloc(g_seg->cands,sizeof(struct cand_ent *)*g_seg->cand_count);
  g_seg->cands[g_seg->cand_count-1] = e;
}

void push_back_singleword_candidate()
{
  seq_ent_t se;
  struct cand_ent *e;
  wtype_t wt;
  int i,n;
  xstr xs;
  se = get_seq_ent_from_xstr(&g_seg->str);
  n = get_nr_dic_ents(se,&g_seg->str);
  for ( i = 0 ; i < n ; i++){
    int ct;
    get_nth_dic_ent_wtype(se,&g_seg->str,i,&wt);
    ct = wtype_get_ct(wt);
    if ( ct == CT_SYUSI || ct == CT_NONE){
      e = (struct cand_ent *)malloc(sizeof(struct cand_ent));
      get_nth_dic_ent_str(se,&g_seg->str,i,&xs);
      e->nr_words = 0;
      e->str.str = xs.str;
      e->str.len = xs.len;
      e->elm = 0;
      push_back_candidate(e);
    }
  }
}

void push_back_noconv_candidate()
{
  /*̵ѴҲ̾ˤʤʿ̾Τߤˤʤɲ*/
  struct cand_ent *e;
  xstr *xs;
  /*Ҥ餬ʤΤ*/
  e = (struct cand_ent *)malloc(sizeof(struct cand_ent));
  e->nr_words = 0;
  e->str.str = xstr_dup_str(&g_seg->str);
  e->str.len = g_seg->str.len;
  e->elm = 0;
  push_back_candidate(e);
  /*˥*/
  e = (struct cand_ent *)malloc(sizeof(struct cand_ent));
  e->nr_words = 0;
  xs = xstr_hira_to_kata(&g_seg->str);
  e->str.str = xstr_dup_str(xs);
  e->str.len = xs->len;
  e->elm = 0;
  free_xstr(xs);
  push_back_candidate(e);
}

void print_candidate(struct cand_ent *c)
{
  putxstr(&c->str);
  printf(":%d",c->score);
}

void print_segment(struct seg_ent *e)
{
  int i;
  putxstr(&e->str);
  printf("(");
  for ( i = 0 ; i < e->cand_count ; i++){
    print_candidate(e->cands[i]);
    printf(",");
  }
  printf(")");
  printf(":\n");
}

/*context.cƽФäȤʪ
 İʾθɬ*/
void make_candidates(struct anthy_context *ac,struct seg_ent *e)
{
  g_seg = e;
  /*ñʸˤꤢƤ롣*/
  expand_segment(e);
  push_back_singleword_candidate();
  /*Ҥ餬ʡʤ̵Ѵȥ롣*/
  push_back_noconv_candidate();
}

int commit_split_ent(struct split_ent *e)
{
  /*
    η̤
    ñʻ줬ꤵ줿֤ǥߥåȤ롣
   */
  struct cand_ent *c;
  xstr head;
  int i,n;
  
  head.str = e->xs.str;
  head.len = e->from;

  /*ʣ(1ޤ)ñǹʸñƤƤ*/
  c = (struct cand_ent *)malloc(sizeof(struct cand_ent));
  c->nr_words = e->nr_words;
  c->str.str = xstr_dup_str(&head);
  c->str.len = head.len;
  c->elm = malloc(sizeof(struct cand_elm)*c->nr_words);
  for ( i = 0 ; i < e->nr_words ; i++){
    c->elm[i].s = e->we[i].se;
    c->elm[i].wt = e->we[i].wt;
    c->elm[i].bias = e->we[i].bias;
    c->elm[i].str = e->we[i].str;
  }
  n = enum_candidates(e,c,0);
  release_cand_ent(c);
  return n;
}
