#ifndef _keybind_h_included_
#define _keybind_h_included_

class Atom;
typedef Atom *keyAtom;

// key modifier mask
#define MOD_NONE 0
#define MOD_SHIFT 1
#define MOD_CTRL 2

struct keyEvent{
  int keycode,keychar,modifier,timestamp;
  void print();
};

#ifdef KEYATOMS
#define EXT
#else
#define EXT extern
#endif

EXT keyAtom A_do_conv;
EXT keyAtom A_cancel;
EXT keyAtom A_next_segment;
EXT keyAtom A_prev_segment;
EXT keyAtom A_commit;
EXT keyAtom A_expand_segment;
EXT keyAtom A_shorten_segment;
EXT keyAtom A_next_candidate;
EXT keyAtom A_delete_back;

bool isBindTo(keyEvent *,keyAtom );

#endif
