#include <xstr.h>
#include "xchar.h"

int is_hira(xchar xc)
{
  if ( ( xc & 0xff00 ) == 0xa400){
    return 1;
  }
  return 0;
}

int is_ascii(xchar xc)
{
  if ( xc < 128 ){
    return 1;
  }
  return 0;
}

int is_num(xchar xc)
{
  if ( xc > 47 && xc < 58 ){
    return 1;
  }
  return 0;
}

int is_num_xstr(xstr *xs)
{
  int i;
  for ( i = 0 ; i < xs->len ; i++){
    if ( !is_num(xs->str[i])){
      return 0;
    }
  }
  return 1;
}

int is_ascii_xstr(xstr *xs)
{
  int i;
  for ( i = 0 ; i < xs->len ; i++){
    if ( !is_ascii(xs->str[i])){
      return 0;
    }
  }
  return 1;
}
