/*
  ˹¤եɤǡβϥĥ꡼롣
  1,ޥŸʤɤäƥȡꥹȤ
  2,ȡꥹȤ鹽ʸڤ
  3,ʸڤ饪ȥޥȥΥդ

  2ϳ̤ʤɤѥ
  "|"ʤɤѥ2Ĥʬ롣

  ȥޥȥѤˤĤƤϡޤäݤʽ
  ȤΤȡ˱ѵȤäƤΤա
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dic.h>
#include <wtype.h>
#include <conf.h>
#include <ruleparser.h>

#include "main.h"
#include "segstruct.h"

/*ǡ¤(ʸ)*/
#define REXT_SEQ 1
#define REXT_LIST 2
#define REXT_WTYPE 3
#define REXT_OR 4
#define REXT_CLOS 5
#define REXT_POSCLOS 6
#define REXT_NEGCLOS 7
/*postprocessˤϽиʤ*/
#define REXT_VBAR 8
#define REXT_STAR 9
#define REXT_PLUS 10
#define REXT_QUESTION 11

typedef struct REx_{
  struct REx_ *next,*prev;
  int type;
  int opt;
  struct REx_ *ref;/*ñ黻Ҥξ*/
  struct REx_ *left,*right;/*黻Ҥξ*/
  struct REx_ *parent;/*黻оݤ黻Ҥ򤵤*/
  seq_ent_t seq;
  wtype_t wt;
  State *initial_state;
  Arrow *arrow_to_final;
}REx;

static REx *error_rex = (REx *)-1;

typedef struct Token_{
  char *str;/*ȡʸȤƤμ*/
  char *literal;/*֥륯ȤǰϤޤ줿*/
  char *opt;/*#ǻϤޤ*/
  char *name;/*ʻ̾*/
  struct Token_ *next,*prev;
}Token;

/*ǡ¤(ޥν)*/
typedef struct Macro_{
  char *name;
  Token token_list;
  struct Macro_ *next;
}Macro;
static Macro gMacros;

/*롼빽ۤδؿ*/
static void link_rex_node(REx *);
static void compile_rex_node(REx *);
static void compile_rex_list_node(REx *);
static void compile_rex_or_node(REx *);// 'or' node
static void compile_rex_negclos_node(REx *);
static void compile_rex_posclos_node(REx *);
static REx *post_parse_rex(REx *);
static REx *post_parse_binary_rex(REx *);
static REx *post_parse_unary_rex(REx *);
static REx *make_rex_tree(Token *t);
static REx *parse_token_list(Token **t);
static void parse_line(char **,int );
static void parse_MacroDef(char *,char **,int);
/*ȡꥹȤ*/
static void print_token_list(Token *);
static void append_token(Token *,char *);
static void tokens_to_list(Token *,char **,int );
static void split_token(Token *);
static int parse_opt_str(char *);
static void add_elm_to_token(Token *,char *);
static Macro *find_macro_by_name(char *);
/*ǡ(¤)*/
static State *alloc_state();
static Arrow *alloc_arrow();
static REx *alloc_rex();
static void free_token(Token *);
static void add_arrow_to_state(State *s,Arrow *a);
/*debug*/
static void print_rex_tree(REx *rex);
static void print_rex_unary_op(REx *rex);

State *alloc_state()
{
  State *s;
  s = malloc(sizeof(State));
  s->arrows.next =0;
  return s;
}

Arrow *alloc_arrow()
{
  Arrow *a;
  a = malloc(sizeof(Arrow));
  return a;
}

REx *alloc_rex()
{
  REx *r;
  r = (REx *)malloc(sizeof(REx));
  r->parent = 0;
  return r;
}

void free_token(Token *t)
{
  Token *p=t->next,*q;
  while(p != t){
    q = p;
    p = p->next;
    free(q->str);
    free(q);
  }
}

/*֤ФƤξ֤ܤɲä*/
void add_arrow_to_state(State *s,Arrow *a)
{
  a->next = s->arrows.next;
  s->arrows.next= a;
}

void append_token(Token *t,char *s)
{
  if ( s[0] == '@' ){
    /*ޥʤΤŸ*/
    Macro *m;
    Token *cur;
    append_token(t,"(");
    m = find_macro_by_name(s);
    for ( cur = m->token_list.next ;cur!= &m->token_list ; cur = cur->next){
      append_token(t,cur->str);
    }
    append_token(t,")");
  }else{
    Token *n;
    n = (Token *)malloc(sizeof(Token));
    n->str = strdup(s);
    n->next = t;
    n->prev = t->prev;
    t->prev->next = n;
    t->prev = n;
    t->literal = 0;
  }
}

void print_token_list(Token *t)
{
  Token *c;
  for ( c = t->next ; c != t ; c = c->next ){
    if ( c->literal ){
      printf("%s",c->literal);
    }
    printf("*%s\n",c->str);
  }
  printf("-\n");
}

void print_rex_unary_op(REx *rex)
{
  printf("clos");
  switch(rex->type){
  case REXT_POSCLOS:
    printf("+");
    break;
  case REXT_NEGCLOS:
    printf("-");
    break;
  }
  printf("( ");
  print_rex_tree(rex->ref);
  printf(") ");
}

void print_rex_tree(REx *rex)
{
  if (!rex){
    printf("_ ");
    return ;
  }
  if ( rex == error_rex ){
    printf("{error} ");
    return ;
  }
  switch(rex->type){
  case REXT_SEQ:
    printf("seq(%x) ",(unsigned)rex->seq);
    break;
  case REXT_WTYPE:
    printf("wtype ");
    break;
  case REXT_LIST:
    printf("( ");
    print_rex_tree(rex->ref);
    printf(") ");
    break;
  case REXT_VBAR:
    printf("| ");
    break;
  case REXT_OR:
    printf("or(");
    print_rex_tree(rex->left);
    printf(",");
    print_rex_tree(rex->right);
    printf(")");
    break;
  case REXT_STAR:
    printf("* ");
    break;
  case REXT_PLUS:
    printf("+ ");
    break;
  case REXT_QUESTION:
    printf("? ");
    break;
  case REXT_NEGCLOS:
  case REXT_POSCLOS:
  case REXT_CLOS:
    print_rex_unary_op(rex);
    break;
  }
  if ( rex->next && rex->next->prev != rex ){
    printf("rex link is broken.\n");
  }
  print_rex_tree(rex->next);
}

void tokens_to_list(Token *l,char **tokens,int nr)
{
  int i;
  l->next = l;
  l->prev = l;
  for ( i = 0 ; i < nr ; i++){
    append_token(l,tokens[i]);
  }
}

/*ȡǤϤ*/
void add_elm_to_token(Token *t,char *s)
{
  switch(*s){
  case '"':
    s[strlen(s)-1] = 0;
    t->literal = &s[1];
    break;
  case '#':
    t->opt = s;
    break;
  default:
    t->name = s;
    break;
  }
}

/*tokenǤʬ䤹*/
void split_token(Token *t)
{
  int len= strlen(t->str);
  int i,inQuote=0;
  char *cur_elm=0;
  char *cc;
  t->literal = 0;
  t->opt = 0;
  t->name = 0;
  for ( i = 0 ; i < len ; i++){
    cc = &t->str[i];
    if ( ! cur_elm ){
      cur_elm = cc;
    }
    switch(*cc){
    case '"':
      inQuote = 1- inQuote;
      break;
    case '.':
      if ( !inQuote ){
	*cc = 0;
      }
      add_elm_to_token(t,cur_elm);
      cur_elm = 0;
      break;
    }
  }
  add_elm_to_token(t,cur_elm);
}

void parse_MacroDef(char *name,char **tokens,int nr)
{
  Token tok;
  Macro *m;

  /*ȡꥹȤŸ*/
  tokens_to_list(&tok,tokens,nr);

  /*ޥФƤƤ*/
  m = find_macro_by_name(name);
  if ( &tok == tok.next ){
    /*ꥹ*/
    m->token_list.next = &m->token_list;
    m->token_list.prev = &m->token_list;
  }else{
    /*⤷ǥޥnameƤʤС
     Ťϥ꡼*/
    m->token_list.next = tok.next;
    m->token_list.prev = tok.prev;
    tok.next->prev = &m->token_list;
    tok.prev->next = &m->token_list;
  }
}

void parse_line(char **tokens,int nr)
{
  /*롼ѡ
    饹ɽ
   */
  REx *rex;
  Token tok_list;
  int level;
  tok_list.str = 0 ;

  if ( nr >2 && tokens[0][0] == '@' && !strcmp(tokens[1],":=")){
    /*饹*/
    parse_MacroDef(tokens[0],&tokens[2],nr-2);
    return ;
  }

  /*ɽä*/
  /*ޤޥŸ򤷤ȡꥹȤ*/
  level = atoi(tokens[0]);
  tokens_to_list(&tok_list,&tokens[1],nr-1);

  /*ȡꥹȤRExΥĥ꡼*/
  rex = make_rex_tree(&tok_list);
  //print_rex_tree(rex);printf("\n");
  //print_token_list(&tok_list);
  free_token(&tok_list);
  if ( !rex || rex == error_rex){
    printf("syntax error in segment struct definition file.\n");
    return ;
  }
  /*ƥΡɤ򥳥ѥ뤹*/
  compile_rex_node(rex);
  /*󥯤*/
  link_rex_node(rex);
  /*Ͽ*/
  register_segstruct(rex->initial_state,level);
}

Macro *find_macro_by_name(char *name)
{
  Macro *m;
  for ( m = gMacros.next ; m ; m = m->next ){
    if ( !strcmp(m->name,name)){
      return m;
    }
  }
  m = (Macro *)malloc(sizeof(Macro));
  m->name = strdup(name);
  m->token_list.next = &m->token_list;
  m->token_list.prev = &m->token_list;
  m->next = gMacros.next;
  gMacros.next = m;
  return m;
}

int parse_opt_str(char *str)
{
  int mask = 0;
  if ( !str ){
    return 0;
  }
  for ( ; *str ; str++){
    switch(*str){
    case 'S':
      mask |= OPT_SUFFIX;
      break;
    }
  }
  return mask;
}

REx *parse_token_list(Token **t)
{
  REx *r;
  Token *tok = (*t);
  char *s = (*t)->str;

  if ( ! s ){
    /*顼*/
    return error_rex;
  }
  *t = (*t)->next;
  
  if (! strcmp(")",s)){
    /*")"ǥꥹȽλ*/
    return 0;
  }

  r = alloc_rex();
  r->prev = 0;
  r->opt = parse_opt_str(tok->opt);
  if (!strcmp("(",s)){
    /*ä*/
    r->type = REXT_LIST;
    r->ref = parse_token_list(t);
    r->next = parse_token_list(t);
    if ( r->ref == error_rex || r->next == error_rex ){
      return error_rex;
    }
    if ( r->next ){
      r->next->prev = r;
    }
    return r;
  }
  /*ȥξ*/
  if ( tok->literal ){
    /*ƥ*/
    xstr *xs;
    r->type = REXT_SEQ;
    xs = cstr_to_xstr(tok->literal);
    r->seq = get_seq_ent_from_xstr(xs);
    if ( ! r->seq ){
        printf("Invalid word(%s) in structdef.\n",tok->literal);
    }
    r->wt = wt_none;
    free_xstr(xs);
  }else if(!strcmp("|",s)){
    r->type = REXT_VBAR;
  }else if(!strcmp("*",s)){
    r->type = REXT_STAR;
  }else if (!strcmp("?",s)){
    r->type = REXT_QUESTION;
  }else if (!strcmp("+",s)){
    r->type = REXT_PLUS;
  }else{
    /*ʻ*/
    wtype_t wt;
    name_to_wtype(tok->name,&wt);
    r->type = REXT_WTYPE;
    r->wt = wt;
  }
  r->next = parse_token_list(t);
  if ( r->next == error_rex ){
    return error_rex;
  }
  if ( r->next ){
    r->next->prev = r;
  }
  return r;
}

REx *post_parse_unary_rex(REx *head)
{
  REx *op;
again:;
  for ( ; head->parent ; head = head->parent);
  for ( op = head->next ; op ; op = op->next ){
    int p = 0;
    switch(op->type){
    case REXT_STAR:
      p = REXT_CLOS;
      break;
    case REXT_PLUS:
      p = REXT_POSCLOS;
      break;
    case REXT_QUESTION:
      p = REXT_NEGCLOS;
      break;
    }
    if ( p ){
      op->type = p;
      op->ref = op->prev;
      op->ref->parent = op;
      if ( op->prev->prev ){
	op->prev->prev->next = op;
      }
      op->prev = op->prev->prev;
      op->ref->next = 0;
      op->ref->prev = 0;
      goto again;
    }
  }
  for ( ; head->parent ; head = head->parent);
  return head;
}

REx *post_parse_binary_rex(REx *head)
{
  REx *op;
again:;
  for ( ; head->parent ; head = head->parent);
  for ( op = head->next ; op && op->next ; op = op->next ){
    if ( op->type == REXT_VBAR ){
      op->left = op->prev;
      op->right = op->next;
      op->type = REXT_OR;
      if ( op->prev->prev ){
	op->prev->prev->next = op;
      }
      op->prev = op->prev->prev;
      if ( op->next->next ){
	op->next->next->prev = op;
      }
      op->next = op->next->next;
      op->left->prev = 0;
      op->right->prev = 0;
      op->left->next = 0;
      op->right->next = 0;
      op->left->parent = op;
      op->right->parent = op;
      goto again;
    }
  }
  for ( ; head->parent ; head = head->parent);
  return head;
}

REx *post_parse_rex(REx *r)
{
  REx *rr;
  if ( !r ){
    return 0;
  } 
  for ( rr = r ; rr ; rr = rr->next ){
    if ( rr->type == REXT_LIST ){
      rr->ref = post_parse_rex(rr->ref);
    }
  }
  r = post_parse_unary_rex(r);
  r = post_parse_binary_rex(r);
  return r;
}

REx *make_rex_tree(Token *token_list)
{
  Token *tok;
  REx *rex;
  append_token(token_list,")");/*ü*/
  for ( tok = token_list->next ; tok != token_list ;
	tok = tok->next ){
    split_token(tok);
  }
  tok = token_list->next;

  rex = parse_token_list(&tok);
  if ( rex == error_rex ){
    return error_rex;
  }

  rex = post_parse_rex(rex);
  if ( rex == error_rex ){
    return error_rex;
  }
  return rex;
}

void link_rex_node(REx *r)
{
  if (!r ){
    return ;
  }
  if ( r->next ){
    r->arrow_to_final->to_state = r->next->initial_state;
  }else{
    /*ξ硢֤̤γؤԤξ
      compile_rex_nodealloc_state()ľ˽뤳Ȥˤ롣
      Ԥξcompile_rex_list_node³롣
     */
  }
  if ( r->type == REXT_LIST ){
    link_rex_node(r->ref);
  }
  link_rex_node(r->next);
}

void compile_rex_list_node(REx *rex)
{
  REx *p;
  Arrow *a;
  State *s;
  compile_rex_node(rex->ref);
  for ( p = rex->ref ; p && p->next ; p= p->next);
  /*pϥꥹȤκǸΥΡɤؤƤ*/
  if ( !p ){
    /*ꥹȤǤ̵*/
    rex->arrow_to_final->type = AT_EPSILON;
    add_arrow_to_state(rex->initial_state,rex->arrow_to_final);
    return ;
  }

  /*ꥹȤƬؤarrow*/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  a->to_state = rex->ref->initial_state;
  add_arrow_to_state(rex->initial_state,a);
  /*ꥹȤκǸߡξ֤ؤ*/
  s = alloc_state();
  p->arrow_to_final->to_state = s;
  /*ߡ֤to_final³*/
  add_arrow_to_state(s,rex->arrow_to_final);
  rex->arrow_to_final->type = AT_EPSILON;
}

void compile_rex_or_node(REx *rex)
{
  Arrow *a;
  State *s;
  compile_rex_node(rex->left);
  compile_rex_node(rex->right);
  /**/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  add_arrow_to_state(rex->initial_state,a);
  a->to_state = rex->left->initial_state;
  a = alloc_arrow();
  a->type = AT_EPSILON;
  add_arrow_to_state(rex->initial_state,a);
  a->to_state = rex->right->initial_state;
  /*Ǥ*/
  s = alloc_state();
  rex->left->arrow_to_final->to_state = s;
  rex->right->arrow_to_final->to_state = s;
  rex->arrow_to_final->type = AT_EPSILON;
  add_arrow_to_state(s,rex->arrow_to_final);
}

void compile_rex_negclos_node(REx *rex)
{
  Arrow *a;
  State *s;
  compile_rex_node(rex->ref);
  /**/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  a->to_state = rex->ref->initial_state;
  add_arrow_to_state(rex->initial_state,a);
  /*и*/
  s = alloc_state();
  rex->ref->arrow_to_final->to_state = s;
  add_arrow_to_state(s,rex->arrow_to_final);
  rex->arrow_to_final->type = AT_EPSILON;
  /*Хѥ*/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  a->to_state = s;
  add_arrow_to_state(rex->initial_state,a);
}

void compile_rex_posclos_node(REx *rex)
{
  Arrow *a;
  State *s;
  compile_rex_node(rex->ref);
  /**/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  a->to_state = rex->ref->initial_state;
  add_arrow_to_state(rex->initial_state,a);
  /*и*/
  s = alloc_state();
  rex->ref->arrow_to_final->to_state = s;
  add_arrow_to_state(s,rex->arrow_to_final);
  rex->arrow_to_final->type = AT_EPSILON;
  /*ϩʬnegclosȰ㤦*/
  a = alloc_arrow();
  a->type = AT_EPSILON;
  a->to_state = rex->initial_state;
  add_arrow_to_state(s,a);
}

void compile_rex_node(REx *rex)
{
  if (!rex ){
    return ;
  }
  rex->initial_state = alloc_state();
  rex->arrow_to_final = alloc_arrow();
  rex->arrow_to_final->to_state = 0;
  rex->arrow_to_final->seq = rex->seq;
  rex->arrow_to_final->wt = rex->wt;
  rex->arrow_to_final->opt = rex->opt;
  compile_rex_node(rex->next);

  switch(rex->type){
  case REXT_SEQ:
    rex->arrow_to_final->type = AT_SEQ;
    add_arrow_to_state(rex->initial_state,rex->arrow_to_final);
    break;
  case REXT_WTYPE:
    rex->arrow_to_final->type = AT_WTYPE;
    add_arrow_to_state(rex->initial_state,rex->arrow_to_final);
    break;
  case REXT_LIST:
    compile_rex_list_node(rex);
    break;
  case REXT_OR:
    compile_rex_or_node(rex);
    break;
  case REXT_NEGCLOS:
    compile_rex_negclos_node(rex);
    break;
  case REXT_POSCLOS:
    compile_rex_posclos_node(rex);
    break;
  default:
    printf("Sorry rex = %x , type = %x\n",
	   (unsigned )rex,(unsigned)rex->type);
    break;
  }
}

/*ƤФ*/
int init_seg_struct_tab()
{
  char *fn;
  char **tokens;
  int nr;
  fn = conf_get_str("STRUCT");
  if (!fn ){
    printf("segment dict unspecified.\n");
    return -1;
  }
  if ( open_file(fn) == -1 ){
    printf("failed to open segment dict (%s).\n",fn);
    return -1;
  }
  
  dic_activate_session(0);
  while(!read_line(&tokens,&nr) ){
    parse_line(tokens,nr);
    free_line();
  }
  close_file();
  return 0;
}

