/*
  segcompse.cƤФơ̤segstruct.c
  assign_word_typeƤӽФ

  ʸñʬ䤹ѥ򸡺롣
  Ȥ
   ֤ˤ -> ֤ˡ  
            -> ֤ˤ  ð
	    Τ褦ʸζڤ󤹤롣
  ޤͥڤ󤷡segstruct
  ʸι¤å
  */
#include <stdlib.h>
#include <stdio.h>
#include <dic.h>
#include <wtype.h>
#include "main.h"
#include "segexpand.h"

/* ΡɤΥҡ */
#define SPLIT_HEAP_SIZE 32

/*߽Υ*/
struct seg_ent *g_seg;

/*ޤǤ˺ä*/
int nr_split_candidates;
/* ŸѤΥХåե*/
struct split_ent *split_heap[SPLIT_HEAP_SIZE];

static int do_expand_segment();
static void free_split_ent_heap();
static int nr_words_in_split_ent(int *);
static int make_word_array(int *,struct split_ent *);
static int get_word_len_from_split_ent(int *,int,int);
static int strip_postfix(xstr *xs);

static void depth_first_search(int *,int);
static void push_back_split_ent_candidate(int *);

int get_word_len_from_split_ent(int *s,int begin,int end)
{
  int i;
  for ( i = 1; i + begin <= end ; i++){
    if ( s[begin+i] ){
      return i;
    }
  }
  return 1;
}

int nr_words_in_split_ent(int *mark)
{
  int i,n;
  for ( i = g_seg->core_from,n= 0; 
	i < g_seg->core_from +g_seg->core_len ; i++){
    if ( mark[i]){
      n++;
    }
  }
  return n;
}

/*split_entseq_ent*/
int make_word_array(int *w,struct split_ent *sp)
{
  int i,j;
  for ( i = 0 ,j = g_seg->core_from ; i < sp->nr_words ; i++){
    xstr *xs = &sp->we[i].str;
    xs->len = get_word_len_from_split_ent(w,j,g_seg->str.len);
    xs->str = &g_seg->str.str[j];
    j+= xs->len;
    sp->we[i].se = get_seq_ent_from_xstr(xs);
  }
  return 0;
}

void print_split_ent(struct split_ent *s)
{
  int i,j;
  for ( i = 0 ; i < s->nr_words ; i++){
    for ( j = 0 ; j < s->we[i].str.len ; j++){
      putxchar(s->we[i].str.str[j]);
    }
    printf(".");
  }
  printf("\n");
}

void free_split_ent(struct split_ent *e)
{
  free(e->we);
  free(e);
}

void free_split_ent_heap()
{
  int i;
  for ( i = 0 ; i < nr_split_candidates ; i++){
    free_split_ent(split_heap[i]);
  }
}

void push_back_split_ent_candidate(int *w)
{
    struct split_ent *e;
    e = malloc(sizeof(struct split_ent));
    e->nr_words = nr_words_in_split_ent(w);
    e->we = malloc(sizeof(struct word_ent)*e->nr_words);
    e->xs = g_seg->str;
    e->len = g_seg->core_len;
    e->from = g_seg->core_from;
    make_word_array(w,e);
    split_heap[nr_split_candidates] = e;
    nr_split_candidates ++;
}

void depth_first_search(int *w,int from)
{
    int n;
    if ( (g_seg->core_from +g_seg->core_len - from ) == 0 ){
      /*ʸΰʬ䤬Ǥ*/
      push_back_split_ent_candidate(w);
      return ;
    }
    if ( nr_split_candidates >= SPLIT_HEAP_SIZE ){
        return ;
    }
    for ( n = g_seg->core_from + g_seg->core_len - from ; n > 0 ; n -- ){
        seq_ent_t se;
        xstr xs;
        xs.str = &g_seg->str.str[from];
        xs.len = n;
        se = get_seq_ent_from_xstr(&xs);
        if ( get_seq_ent_type(se) & ST_WORD ){
            w[from+n] = 1;
            depth_first_search(w,from+n);
            w[from+n] = 0;
        }
    }
}

int do_expand_segment()
{
  int n,level;
  int *w,i;

  nr_split_candidates = 0;
  w = alloca(sizeof(int)*(g_seg->str.len+1));
  for ( i = 0 ; i <= g_seg->str.len ; i++){
      w[i] = 0;
  }
  w[g_seg->core_from] = 1;
  w[g_seg->core_from+g_seg->core_len] = 1;

  depth_first_search(w,g_seg->core_from);

  n = 0;
  level = 0;
  for ( level = 0 ; level < 10 && n == 0 ; level ++){
    for ( i = 0 ; i < nr_split_candidates ; i++){
      //print_split_ent(split_heap[i]);
      n += assign_word_type(split_heap[i],level);
    }
  }

  /*QueueΤΤ*/
  free_split_ent_heap();
  return n;
}

int strip_postfix(xstr *xs)
{
  int i;
  for ( i = xs->len ; i > 0 ;i--){
    if (is_hira(xs->str[i-1]) || is_ascii(xs->str[i-1])){
      return i;
    }
  }
  return 0;
}

void expand_segment(struct seg_ent *e)
{
  int t,i,len;
  g_seg = e;

  /*䤬Ǥʤä顢夫龯ڤȤ*/
  len = strip_postfix(&e->str);
  if ( len > 8){
    t = 4;
  }else if ( len > 5 ){
    t = 3;
  }else {
    t = 2;
  }
  for ( i = 0 ; i < t ; i++){
    e->core_from = 0;
    e->core_len = len - i;
    if ( do_expand_segment() ){
      return ;
    }
  }
}
